const SMASHINOY_MPLEX_URL = "http://comet1.smashinoy.ru/";

var smashinoy_main = {

	interval : 60000,


	__construct : function() {
		//this._label = document.getElementById("smashinoynotify");
	},

	__destruct : function() {
		smashinoy_connection.cleanup(true);
	},

	
	gosite : function(e) {
		smashinoy_lib.link("http://smashinoy.ru/user/mail/");
	},
	
	start : function() {
		if (smashinoy_lib.getWindows().length==1) {
			setTimeout(function() {
				var identifier = smashinoy_main.getCharPref('ident', 'testnotify');

				mplexor = new Multiplexor(identifier);
				mplexor.run();
			}, 1000);
		}
		
	},
	
	getCharPref : function(name,defaultval) {
		this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
						.getService(Components.interfaces.nsIPrefService)
						.getBranch("extensions.smashinoy.");
		this.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
		try {
			return this.prefs.getCharPref(name)
		}
		catch (e) {
			this.prefs.setCharPref(name, defaultval)
			return defaultval;
		}
	},
	
	getBoolPref : function(name, defaultval) {
		this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
						.getService(Components.interfaces.nsIPrefService)
						.getBranch("extensions.smashinoy.");
		this.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
		try {
			return this.prefs.getBoolPref(name)
		}
		catch (e) {
			this.prefs.setBoolPref(name, defaultval)
			return defaultval;
		}
	},
	
	showpopup : function(r) {
		if ( smashinoy_main.getBoolPref('popup', 'true') == false ) return;
		
		smashinoy_lib.notify("sMashinoy", "New ("+r.value+") mail available!");
	},
	
	playSound : function() {
		if ( smashinoy_main.getBoolPref('sound', 'true') == false ) return;
		
		var sound = Components.classes["@mozilla.org/sound;1"]
							.createInstance(Components.interfaces.nsISound);
		var ioService = Components.classes["@mozilla.org/network/io-service;1"]
							.getService(Components.interfaces.nsIIOService);
		try {
			var wav = smashinoy_main.getCharPref('wavfile', 'chrome://smashinoy/content/ding.wav');
			var uri = ioService.newURI(wav, null, null);
			sound.play(uri);
		} catch (e) {
			GMC_Util.debug(e);
		}
	},
	
	
	MultiplexorProcessData : function(r) {
		if ( ! r ) return;
		
		
		r = r[0].data;
		
		if ( r.type == 'mail' ) {
			this._label = document.getElementById("smashinoynotify");
			
			if ( r.value > 0 ) {
				if ( r.isnew > 0 ) {
					this.showpopup(r);
					this.playSound();
				}
				this._label.label=r.value;
			}
			else {
				this._label.label = "0";
			}
		}
	}
	
	

}



window.addEventListener("load", smashinoy_main.start, false);
