const SMASHINOY_ID = "notify@smashinoy.ru";

	var listener = {
	  observe: function(subject, topic, data) {
			if ( topic != 'alertclickcallback' ) return;
			
			if ( data == 'mail' ) smashinoy_lib.link("http://smashinoy.ru/user/mail/");
		}
	  }

function Dump(d,l) {
    if (l == null) l = 1;
    var s = '';
    if (typeof(d) == "object") {
        s += typeof(d) + " {\n";
        for (var k in d) {
            for (var i=0; i<l; i++) s += "  ";
            s += k+": " + Dump(d[k],l+1);
        }
        for (var i=0; i<l-1; i++) s += "  ";
        s += "}\n"
    } else {
        s += "" + d + "\n";
    }
    return s;
}

var smashinoy_lib = {

	browseFile : function(e) {
		//alert('dd');
		
		var picker = Components.classes["@mozilla.org/filepicker;1"]
			.createInstance(Components.interfaces.nsIFilePicker);
		picker.init(window, "selectFile", picker.modeOpen);
		if (picker.show()==picker.returnOK) {
			//alert(picker.fileURL.spec);
			document.getElementById("wav").value = picker.fileURL.spec;
		}
		
	
	},
	
	resetWav : function(e) {
		document.getElementById("wav").value = 'chrome://smashinoy/content/ding.wav';
	},

	notify : function(title, text) {
		if (this.checkPlatformVersion("1.9")<0) return;

		var as = Components.classes["@mozilla.org/alerts-service;1"]
							.getService(Components.interfaces.nsIAlertsService);
		as.showAlertNotification("chrome://smashinoy/skin/icon.png", title, text, true, "mail", listener);
	},

	checkLeftClick : function(button) {
		return button==0;
	},

	checkMiddleClick : function(button) {
		return button==1;
	},

	checkRightClick : function(button) {
		return !this.checkLeftClick(button) && !this.checkMiddleClick(button);
	},

	checkPlatformVersion : function(version) {
		var info = Components.classes["@mozilla.org/xre/app-info;1"]
						.getService(Components.interfaces.nsIXULAppInfo);
		return Components.classes["@mozilla.org/xpcom/version-comparator;1"]
						.getService(Components.interfaces.nsIVersionComparator)
						.compare(info.platformVersion, version);
	},
	
	
	getWindowMediator : function() {
		return Components.classes["@mozilla.org/appshell/window-mediator;1"]
						.getService(Components.interfaces.nsIWindowMediator);
	},
	
	
	getWindows : function() {
		var windows = [];
		var wm = this.getWindowMediator();
		var e = wm.getEnumerator("navigator:browser");
		while(e.hasMoreElements()) {
			windows.push(e.getNext());
		}
		return windows;
	},
	
	
	link : function(url) {
		var window = this.getWindowMediator().getMostRecentWindow("navigator:browser");
		window.gBrowser.selectedTab = window.gBrowser.addTab(url);
	},
	

	getFile : function(name) {
		return Components.classes["@mozilla.org/extensions/manager;1"]
					.getService(Components.interfaces.nsIExtensionManager)
					.getInstallLocation(SMASHINOY_ID)
					.getItemFile(SMASHINOY_ID, name);
	},

	getFileContent : function(name) {
		var file = this.getFile(name);
		var data = "";
		var fstream = Components.classes["@mozilla.org/network/file-input-stream;1"]
							.createInstance(Components.interfaces.nsIFileInputStream);
		var sstream = Components.classes["@mozilla.org/scriptableinputstream;1"]
							.createInstance(Components.interfaces.nsIScriptableInputStream);
		fstream.init(file, -1, 0, 0);
		sstream.init(fstream);

		var str = sstream.read(1024);
		while (str.length > 0) {
			data += str;
			str = sstream.read(1024);
		}

		sstream.close();
		fstream.close();
		return data;
	}
	
	
}